﻿// * * * * * * * * * dbi technologies inc. * * * * * * * * * 
// * * * * * * *  xAIgent Sample application * * * * * * * *
// * * * * * * * * * * Copyright 2016  * * * * * * * * * * *

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace xAIgentSampleCSharp
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }

        private void ButtonRun_Click(object sender, EventArgs e)
        {

            xAIgentService.DBIXServiceClient myxAIgentService = new xAIgentService.DBIXServiceClient();    //Create an instance of the xAIgent restful service
            xAIgentService.ExtractionRequest myxAIgentRequest = new xAIgentService.ExtractionRequest();    //Create an instance of the xAIgent request
            xAIgentService.ExtractionResult myxAIgentResponse = new xAIgentService.ExtractionResult();    //Create an instance of the xAIgent result
            myxAIgentRequest.ApplicationID = "xAIgent C# sample";     //Set the application ID to identify the application calling the xAIgent service
            myxAIgentRequest.LanguageID = 0;     //Set the language for the document to be extracted to Auto Detect.  NOTE: This does not work with Japanese or Korean
            myxAIgentRequest.NumberOfPhrasesToReturn = 5;    //Set the number of phrases to return
            myxAIgentRequest.SubscriptionID = "Your Subscription ID";    //Set the Subscription ID for authentication to use the xAIgent service
            myxAIgentRequest.XTractionDocument = this.TextBoxExtractee.Text;   //Set the document for extraction to the text in the TextBoxExtractee text box

            try
            {

                myxAIgentResponse = myxAIgentService.GetExtraction(myxAIgentRequest);    //Run the xAIgent Service to extract the text and return the key phrases.

                int myResultsCounter = 1;
                this.TextBoxResults.Text = "";

                if (myxAIgentResponse.KeyPhrases.Count() > 0)
                {

                    //Process each key phrase object in the response.
                    foreach (xAIgentService.KeyPhrase keyPhrase2Process in myxAIgentResponse.KeyPhrases)
                    {
                        keyPhrase2Process.Phrase = keyPhrase2Process.Phrase.ToUpper();
                        keyPhrase2Process.Highlight = keyPhrase2Process.Highlight;

                        //Output the keyphrase object to the results text box.
                        this.TextBoxResults.Text = this.TextBoxResults.Text + myResultsCounter.ToString() + ". " + keyPhrase2Process.Phrase + System.Environment.NewLine + "Score: " + keyPhrase2Process.Score.ToString() + System.Environment.NewLine + "Highlight: " + keyPhrase2Process.Highlight + System.Environment.NewLine + System.Environment.NewLine;

                        myResultsCounter = myResultsCounter + 1;
                    }

                }
                else

                    this.TextBoxResults.Text = "No Results were returned.";

            }

            catch (Exception ex)
            {

                this.TextBoxResults.Text = ex.Message.ToString();

            }

        }

        private void buttonGetTokenStatus_Click(object sender, EventArgs e)
        {

            //Create an instance of the xAIgent service.
            xAIgentService.DBIXServiceClient myxAIgent = new xAIgentService.DBIXServiceClient();
            //Create a TokenStatusRequest object.
            xAIgentService.TokenStatusRequest myTokenStatusRequest = new xAIgentService.TokenStatusRequest();
            //DEVELOPER NOTE: Set your Subscription ID as the Token2Inspect on the request.
            myTokenStatusRequest.Token2Inspect = "Your Subscription ID";    

            try
            {
                //Use the GetTokenStatus method on the xAIgent service to return a TokenStatusResult object.
                xAIgentService.TokenStatusResult myRequestResult = myxAIgent.GetTokenStatus(myTokenStatusRequest);
                string messageLine1 = "";

                if (myRequestResult.TokenValid == 1)
                    messageLine1 = "Token Valid";
                else
                    messageLine1 = "Token Not Valid";

                string tokenStatusDescription = "";

                switch (myRequestResult.TokenStatus)
                {
                    case 1:
                        tokenStatusDescription = "Token Active";
                        break;
                    case 2:
                        tokenStatusDescription = "Token Active Pending Auto Step";
                        break;
                    case 3:
                        tokenStatusDescription = "Token Active Period Maximum Reached";
                        break;
                    default:
                        tokenStatusDescription = "Token Inactive";
                        break;
                }

                string messageLine2 = tokenStatusDescription;
                string messageLine3 = "Days to Transaction Count Reset: " + myRequestResult.Days2Reset.ToString();
                string messageLine4 = "Period Maximum Transactions: " + myRequestResult.TransactionsMaximum.ToString();
                string messageLine5 = "Period Transactions Remaining: " + myRequestResult.TransactionsRemaining.ToString();

                MessageBox.Show(messageLine1 + Environment.NewLine + Environment.NewLine + messageLine2 + Environment.NewLine + Environment.NewLine + messageLine3 + Environment.NewLine + Environment.NewLine + messageLine4 + Environment.NewLine + Environment.NewLine + messageLine5, "Token Status");

            }

            catch (Exception ex)
            {
                MessageBox.Show("An Error occurred getting the token status ..." + Environment.NewLine + Environment.NewLine + ex.Message);
            }
        }
    }
}
